package locks;

import java.util.concurrent.atomic.AtomicInteger;

public class MyLock2//implementazione corretta, compatibile con piu' di un Thread
										// dentro alla regione critica
{
	private AtomicInteger i;

	public MyLock2(int init)//accetto al massimo init Thread nella regione critica
	{
		i = new AtomicInteger(init);
		locker = new LinkedList<Thread>();
	}

	public MyLock2()
	{
		this(1);//default mutex singola
	}

	public boolean tryLock()
	{
		int tmp = i.decrementAndGet();
		if(tmp < 0)//se e' sceso sotto zero, allora non potevo entrare anche io -> rewind e return false
		{
			i.incrementAndGet();
			return false;
		}
		// se sono qui, potevo entrare. Ho gia' decrementato il contatore, ma devo dire che ci sono anche io..... ok, con quello che so ora, non posso farlo in modo Thread safe
		return true;
	}

	public boolean unlock()
	{
		if(locker != null && locker.equals(Thread.currentThread()))
		// non e' atomico, ma se non sono io, certamente non divertero' io nel frattempo
		// al contrario, se sono io -> allora ho il lock e nessuno tranne me
		// lo puo' cambiare
		{
			locker = null;
			i.decrementAndGet();
			return true;
		}
		return false;
	}
}
