package net;

import java.net.*;
import java.io.*;
import java.util.*;

public class ClientTCP
{
	public static void main(String[] argv)
	{
		int port = 1234;
		if(argv.length > 0)
		{
			try
			{
				port = Integer.parseInt(argv[0]);
			}
			catch(NumberFormatException nfe)
			{
				nfe.printStackTrace();
			}
		}

		try
		{
			Socket s = new Socket("127.0.0.1", port);
			PrintWriter pw = new PrintWriter(s.getOutputStream());
			BufferedReader br = new BufferedReader(new InputStreamReader(s.getInputStream()));
	
			Scanner stdin = new Scanner(System.in);
			do
			{
				System.out.print("Cosa vuoi dire al server? > ");
				String line = stdin.nextLine();
				pw.println(line);
				pw.flush();
				System.out.println("Lui ti risponde <" + br.readLine() + ">");
			}
			while(stdin.hasNextLine());
		}
		catch(UnknownHostException uhe)
		{
			uhe.printStackTrace();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
}
